com.jnape.palatable.lambda.functions.builtin.fn3

## Class ZipWith<A,B,C>

- java.lang.Object
- - com.jnape.palatable.lambda.functions.builtin.fn3.ZipWith<A,B,C>

- Type Parameters:
    `A` - The first input Iterable element type
    `B` - The second input Iterable element type
    `C` - The output Iterable element type
  All Implemented Interfaces:
    Fn1<Fn2<? super A,? super B,? extends C>,Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>>, Fn2<Fn2<? super A,? super B,? extends C>,Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>, Fn3<Fn2<? super A,? super B,? extends C>,Iterable<A>,Iterable<B>,Iterable<C>>, Applicative<Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>,Fn1<Fn2<? super A,? super B,? extends C>,?>>, Cartesian<Fn2<? super A,? super B,? extends C>,Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>,Fn1<?,?>>, Cocartesian<Fn2<? super A,? super B,? extends C>,Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>,Fn1<?,?>>, Contravariant<Fn2<? super A,? super B,? extends C>,Profunctor<?,Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>,Fn1<?,?>>>, Functor<Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>,Fn1<Fn2<? super A,? super B,? extends C>,?>>, Profunctor<Fn2<? super A,? super B,? extends C>,Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>,Fn1<?,?>>, Monad<Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>,Fn1<Fn2<? super A,? super B,? extends C>,?>>, MonadReader<Fn2<? super A,? super B,? extends C>,Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>,Fn1<Fn2<? super A,? super B,? extends C>,?>>, MonadRec<Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>,Fn1<Fn2<? super A,? super B,? extends C>,?>>, MonadWriter<Fn2<? super A,? super B,? extends C>,Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<C>>>,Fn1<Fn2<? super A,? super B,? extends C>,?>>

      public final class ZipWith<A,B,C>
      extends Object
      implements Fn3<Fn2<? super A,? super B,? extends C>,Iterable<A>,Iterable<B>,Iterable<C>>

  Zip together two `Iterable`s by applying a zipping function to the successive elements of each `Iterable` until one of them runs out of elements. Returns an `Iterable` containing the results.
  See Also:
    `Zip`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Iterable<C>` | `checkedApply(Fn2<? super A,? super B,? extends C> zipper, Iterable<A> as, Iterable<B> bs)`
    `static <A,B,C> ZipWith<A,B,C>` | `zipWith()`
    `static <A,B,C> Fn2<Iterable<A>,Iterable<B>,Iterable<C>>` | `zipWith(Fn2<? super A,? super B,? extends C> zipper)`
    `static <A,B,C> Fn1<Iterable<B>,Iterable<C>>` | `zipWith(Fn2<? super A,? super B,? extends C> zipper, Iterable<A> as)`
    `static <A,B,C> Iterable<C>` | `zipWith(Fn2<? super A,? super B,? extends C> zipper, Iterable<A> as, Iterable<B> bs)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `apply, apply, apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn3, fn3, fn3, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `checkedApply, curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public Iterable<C> checkedApply(Fn2<? super A,? super B,? extends C> zipper,
                                          Iterable<A> as,
                                          Iterable<B> bs)

      Specified by:
        `checkedApply` in interface `Fn3<Fn2<? super A,? super B,? extends C>,Iterable<A>,Iterable<B>,Iterable<C>>`

    - #### zipWith

          public static <A,B,C> ZipWith<A,B,C> zipWith()

    - #### zipWith

          public static <A,B,C> Fn2<Iterable<A>,Iterable<B>,Iterable<C>> zipWith(Fn2<? super A,? super B,? extends C> zipper)

    - #### zipWith

          public static <A,B,C> Fn1<Iterable<B>,Iterable<C>> zipWith(Fn2<? super A,? super B,? extends C> zipper,
                                                                     Iterable<A> as)

    - #### zipWith

          public static <A,B,C> Iterable<C> zipWith(Fn2<? super A,? super B,? extends C> zipper,
                                                    Iterable<A> as,
                                                    Iterable<B> bs)